<?php

add_action('wp_ajax_insert_record', array('NF5_Database_Actions','insert_record'));
add_action('wp_ajax_update_record', array('NF5_Database_Actions','update_record'));
add_action('wp_ajax_delete_record', array('NF5_Database_Actions','delete_record'));
add_action('wp_ajax_duplicate_record', array('NF5_Database_Actions','duplicate_record'));

add_action('wp_ajax_preview_nex_form', array('NF5_Database_Actions','preview_nex_form'));
add_action('wp_ajax_get_forms', array('NF5_Database_Actions','get_forms'));
add_action('wp_ajax_load_nex_form', array('NF5_Database_Actions','load_nex_form'));
add_action('wp_ajax_get_email_setup', array('NF5_Database_Actions','get_email_setup'));
add_action('wp_ajax_get_options_setup', array('NF5_Database_Actions','get_options_setup'));
add_action('wp_ajax_load_form_entries', array('NF5_Database_Actions','load_form_entries'));
add_action('wp_ajax_populate_form_entry', array('NF5_Database_Actions','populate_form_entry'));
add_action('wp_ajax_load_pagination', array('NF5_Database_Actions','load_pagination'));

add_action( 'wp_ajax_save_email_config', array('NEXForms_admin','save_email_config'));
add_action( 'wp_ajax_save_script_config', array('NEXForms_admin','save_script_config'));
add_action( 'wp_ajax_do_form_import', array('NEXForms_admin','do_form_import'));
add_action( 'wp_ajax_save_style_config', array('NEXForms_admin','save_style_config'));
add_action( 'wp_ajax_save_other_config', array('NEXForms_admin','save_other_config'));

add_action('wp_ajax_load_conditional_logic', array('NF5_Database_Actions','load_conditional_logic'));
add_action('wp_ajax_nf_send_test_email', array('NF5_Database_Actions','nf_send_test_email'));

add_action( 'wp_ajax_do_form_import', array('NF5_Database_Actions','do_form_import'));
add_action('wp_ajax_update_paypal', array('NF5_Database_Actions','update_paypal'));
add_action( 'wp_ajax_buid_paypal_products', array('NF5_Database_Actions','buid_paypal_products'));

add_action('wp_ajax_get_data', array('NF5_Database_Actions','NF5_get_data'));

if(!class_exists('NF5_Database_Actions'))
	{
	class NF5_Database_Actions{

/* INSERT */
		public function insert_record(){
			global $wpdb;
			$fields 	= $wpdb->get_results("SHOW FIELDS FROM " . $wpdb->prefix .filter_var($_POST['table'],FILTER_SANITIZE_STRING));
			$field_array = array();
			foreach($fields as $field)
				{
				if(isset($_POST[$field->Field]))
					{
					$field_array[$field->Field] = $_POST[$field->Field];
					}	
				}
			$insert = $wpdb->insert ( $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING), $field_array );
			echo $wpdb->insert_id;
			die();
		}
		
/* UPDATE */
		public function update_record(){
			global $wpdb;
			$fields 	= $wpdb->get_results("SHOW FIELDS FROM " . $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING));
			$field_array = array();
			foreach($fields as $field)
				{
				if(isset($_POST[$field->Field]))
					{
					if(is_array($_POST[$field->Field]))
						$field_array[$field->Field] = json_encode($_POST[$field->Field],JSON_FORCE_OBJECT);
					else
						$field_array[$field->Field] = $_POST[$field->Field];
					}	
				}
			$update = $wpdb->update ( $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING), $field_array, array(	'Id' => filter_var($_POST['edit_Id'],FILTER_SANITIZE_NUMBER_INT)) );
			echo filter_var($_POST['edit_Id'],FILTER_SANITIZE_NUMBER_INT);
			die();
		}

	public function update_paypal(){
		global $wpdb;
		$fields 	= $wpdb->get_results("SHOW FIELDS FROM " . $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING));
		$field_array = array();
		foreach($fields as $field)
			{
			if(isset($_POST[$field->Field]))
				{
				if(is_array($_POST[$field->Field]))
					$field_array[$field->Field] = json_encode($_POST[$field->Field],JSON_FORCE_OBJECT);
				else
					$field_array[$field->Field] = $_POST[$field->Field];
				}	
			}
		
		$get_row = $wpdb->get_var('SELECT nex_forms_Id FROM '. $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING).' WHERE nex_forms_Id='.filter_var($_POST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT));
		
		if(!$get_row)
			$insert = $wpdb->insert ( $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING), $field_array );
		else
			$update = $wpdb->update ( $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING), $field_array, array(	'nex_forms_Id' => filter_var($_POST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT)) );
			
		echo filter_var($_POST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT);
		die();
		}
		
		
		
	public function buid_paypal_products(){
	
		global $wpdb;
		
		$get_paypal = $wpdb->get_row('SELECT * FROM '. $wpdb->prefix .'wap_nex_forms_paypal WHERE nex_forms_Id = '.filter_var($_POST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT).' ');
		
		$form = $wpdb->get_row('SELECT * FROM '. $wpdb->prefix .'wap_nex_forms WHERE Id = '.filter_var($_POST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT).' ');
		
		
		$products = explode('[end_product]',$get_paypal->products);
		$i=1;
		foreach($products as $product)
			{

				$item_name =  explode('[item_name]',$product);
				$item_name2 =  explode('[end_item_name]',$item_name[1]);
				
				
				$item_qty =  explode('[item_qty]',$product);
				$item_qty2 =  explode('[end_item_qty]',$item_qty[1]);
				
				$map_item_qty =  explode('[map_item_qty]',$product);
				$map_item_qty2 =  explode('[end_map_item_qty]',$map_item_qty[1]);
				
				$set_quantity =  explode('[set_quantity]',$product);
				$set_quantity2 =  explode('[end_set_quantity]',$set_quantity[1]);
				
				$item_amount =  explode('[item_amount]',$product);
				$item_amount2 =  explode('[end_item_amount]',$item_amount[1]);
				
				$map_item_amount =  explode('[map_item_amount]',$product);
				$map_item_amount2 =  explode('[end_map_item_amount]',$map_item_amount[1]);
				
				$set_amount =  explode('[set_amount]',$product);
				$set_amount2 =  explode('[end_set_amount]',$set_amount[1]);
				
				
				
				
			if($item_name2[0])
				{
				$set_products .= '<div class="row paypal_product">';		
					$set_products .= '<div class="row">';
						$set_products .= '<div class="panel panel-default">';
							$set_products .= '<div class="panel-heading"><span class="product_number">Item '.$i.'</span><div class="btn btn-default btn-sm remove_paypal_product"><span class="fa fa-close"></span></div></div>';
							$set_products .= '<div class="panel-body">';
								
								$set_products .= '<input style="width:100% !important" placeholder="Item Name" name="item_name" class="form-control" value="'.$item_name2[0].'">';
							
								$set_products .= '<br><div class="pp_product_quantity">';
									$set_products .= '<label class="pp_product_label">Quantity</label>';
									$set_products .= '<div class="btn btn-sm btn-default static_value '.(($set_quantity2[0]=='static') ? 'active' : '').'">Static Value</div>';
									$set_products .= '<div class="btn btn-sm btn-default field_value '.(($set_quantity2[0]=='map') ? 'active' : '').'">Map Field</div>';
									$set_products .= '<input type="hidden" name="set_quantity" value="'.$set_quantity2[0].'">';
									$set_products .= '<input type="hidden" name="selected_qty_field" value="'.$map_item_qty2[0].'">';
									$set_products .= '<input value="'.$item_qty2[0].'"  type="text" style="width:100% !important" placeholder="Quantity" name="item_quantity" class="form-control '.(($set_quantity2[0]!='static') ? 'hidden' : '').'">';
									$set_products .= '<select name="map_item_quantity" class="form-control '.(($set_quantity2[0]=='static') ? 'hidden' : '').'" data-selected="'.$map_item_qty2[0].'"><option value="0">--- Map Field ---</option></select>';
								$set_products .= '</div>';
								
								$set_products .= '<br><div class="pp_product_amount">';
									$set_products .= '<label class="pp_product_amount">Amount</label>';
									$set_products .= '<div class="btn btn-sm btn-default static_value '.(($set_amount2[0]=='static') ? 'active' : '').'">Static Value</div>';
									$set_products .= '<div class="btn btn-sm btn-default field_value '.(($set_amount2[0]=='map') ? 'active' : '').'">Map Field</div>';
									$set_products .= '<input type="hidden" name="set_amount" value="'.$set_amount2[0].'">';
									$set_products .= '<input type="hidden" name="selected_amount_field" value="'.$map_item_amount2[0].'">';
									$set_products .= '<input  value="'.$item_amount2[0].'" type="text" style="width:100% !important" placeholder="Amount" name="item_amount" class="form-control '.(($set_amount2[0]=='map') ? 'hidden' : '').'">';
									$set_products .= '<select name="map_item_amount" class="form-control '.(($set_amount2[0]=='static') ? 'hidden' : '').'" data-selected="'.$map_item_amount2[0].'"><option value="0">--- Map Field ---</option></select>';
								$set_products .= '</div>';
							
							$set_products .= '</div>';
						$set_products .= '</div>';
					$set_products .= '</div>';
				$set_products .= '</div>';
				
				$i++;	
				
				
				
				
				
				
				}
				
				
				
			}	
		
		$output .= '<div class="paypal_items_list" style="display:none;">';
								
								
							
								$output .= '<div class="row paypal_product_clone hidden">';
									$output .= '
									
									<div class="row">
  
													  <div class="panel panel-default">
													  <div class="panel-heading"><span class="product_number">Item 1</span><div class="btn btn-default btn-sm remove_paypal_product"><span class="fa fa-close"></span></div></div>
													<div class="panel-body"><input style="width:100% !important" placeholder="Item Name" name="item_name" class="form-control">
													
													  <br><div class="pp_product_quantity">
													  <label class="pp_product_label">Quantity</label>
													  
													  <div class="btn btn-sm btn-default static_value active">Static Value</div>
													  <div class="btn btn-sm btn-default field_value">Map Field</div>
														  <input type="hidden" name="set_quantity" value="static">
														  <input  type="text" style="width:100% !important" placeholder="Quantity" name="item_quantity" class="form-control">
														  <select name="map_item_quantity" class="form-control hidden"><option value="0">--- Map Field ---</option></select>
													 
													  </div>
														
														<br><div class="pp_product_amount">
													  <label class="pp_product_amount">Amount</label>
													  
													  <div class="btn btn-sm btn-default static_value active">Static Value</div>
													  <div class="btn btn-sm btn-default field_value">Map Field</div>
														  <input type="hidden" name="set_amount" value="static">
														  <input type="text" style="width:100% !important" placeholder="Amount" name="item_amount" class="form-control">
														  <select name="map_item_amount" class="form-control hidden"><option value="0">--- Map Field ---</option></select>
													 
													  </div>
														
														
															</div>
														</div>
													</div>
																
																';
														$output .= '</div>';
														
								$output .= '<div class="paypal_products">'.((!empty($products)) ? $set_products : '').'</div>';
								
								$output .= '<button id="add_paypal_product" class="btn btn-sm add_paypal_product tab">';
									$output .= 'Add Item';
								$output .= '</button>';
								
							$output .= '</div>';
							
							$output .= '<div class="paypal_setup">';
								
								$output .= '<div class="btn-toolbar" role="toolbar">';
								
									$output .= '<div class="btn-group go_to_paypal" role="group">
										<small>Go To Paypal</small>
										<button data-value="no" title="Go to paypal after the form is submmited" type="button" class="btn btn-default paypal_no '.((!$form->is_paypal || $form->is_paypal=='no') ? 'active' : '' ).'"><span class="btn-tx">No</span></button>
										<button data-value="yes" title="Dont go to paypal after the form is submmited" type="button" class="btn btn-default '.(($form->is_paypal=='yes') ? 'active' : '' ).' "><span class="btn-tx">Yes</span></button>
										</div>';
									
									$output .= '<div class="btn-group paypal_environment" role="group">
										<small>PayPal Environment</small>
										<button data-value="sandbox" title="Use PayPal Testing environment" type="button" class="btn btn-default  '.((!$get_paypal->environment || $get_paypal->environment=='sandbox') ? 'active' : '' ).'"><span class="btn-tx">Sandbox</span></button>
										<button data-value="live" title="Use PayPal Live environment" type="button" class="btn btn-default  '.(($get_paypal->environment=='live') ? 'active' : '' ).' "><span class="btn-tx">Live</span></button>
										</div>';
								$output .= '</div>';
								
								
								$output .= '<small>Business</small><input type="text" placeholder="Paypal Email address/ Paypal user ID" value="'.$get_paypal->business.'" name="business" class="form-control">';
								$output .= '<small>Return URL</small><input type="text" placeholder="Leave blank to return back to the original form" value="'.$get_paypal->return_url.'" name="return" class="form-control">';
								$output .= '<small>Cancel URL</small><input type="text" placeholder="Cancel URL" value="'.$get_paypal->cancel_url.'" name="cancel_url" class="form-control">';
								
								$output .= '<small>Currency</small><select name="currency_code" class="form-control" data-selected="'.$get_paypal->currency_code.'">
												  <option selected="" value="USD">--- Select ---</option>
												  <option value="AUD">Australian Dollar</option>
												  <option value="BRL">Brazilian Real</option>
												  <option value="CAD">Canadian Dollar</option>
												  <option value="CZK">Czech Koruna</option>
												  <option value="DKK">Danish Krone</option>
												  <option value="EUR">Euro</option>
												  <option value="HKD">Hong Kong Dollar</option>
												  <option value="HUF">Hungarian Forint </option>
												  <option value="ILS">Israeli New Sheqel</option>
												  <option value="JPY">Japanese Yen</option>
												  <option value="MYR">Malaysian Ringgit</option>
												  <option value="MXN">Mexican Peso</option>
												  <option value="NOK">Norwegian Krone</option>
												  <option value="NZD">New Zealand Dollar</option>
												  <option value="PHP">Philippine Peso</option>
												  <option value="PLN">Polish Zloty</option>
												  <option value="GBP">Pound Sterling</option>
												  <option value="SGD">Singapore Dollar</option>
												  <option value="SEK">Swedish Krona</option>
												  <option value="CHF">Swiss Franc</option>
												  <option value="TWD">Taiwan New Dollar</option>
												  <option value="THB">Thai Baht</option>
												  <option value="TRY">Turkish Lira</option>
												  <option value="USD">U.S. Dollar</option>
												</select>';
								$output .= '<small>Language</small><select name="paypal_language_selection"  class="form-control"  data-selected="'.$get_paypal->lc.'">
												<option selected="" value="US"> --- Select ---</option>
												<option value="AU">Australia</option>
												<option value="AT">Austria</option>
												<option value="BE">Belgium</option>
												<option value="BR">Brazil</option>
												<option value="CA">Canada</option>
												<option value="CH">Switzerland</option>
												<option value="CN">China</option>
												<option value="DE">Germany</option>
												<option value="ES">Spain</option>
												<option value="GB">United Kingdom</option>
												<option value="FR">France</option>
												<option value="IT">Italy</option>
												<option value="NL">Netherlands</option>
												<option value="PL">Poland</option>
												<option value="PT">Portugal</option>
												<option value="RU">Russia</option>
												<option value="US">United States</option>
												<option value="da_DK">Danish(for Denmark only)</option>
												<option value="he_IL">Hebrew (all)</option>
												<option value="id_ID">Indonesian (for Indonesia only)</option>
												<option value="ja_JP">Japanese (for Japan only)</option>
												<option value="no_NO">Norwegian (for Norway only)</option>
												<option value="pt_BR">Brazilian Portuguese (for Portugaland Brazil only)</option>
												<option value="ru_RU">Russian (for Lithuania, Latvia,and Ukraine only)</option>
												<option value="sv_SE">Swedish (for Sweden only)</option>
												<option value="th_TH">Thai (for Thailand only)</option>
												<option value="tr_TR">Turkish (for Turkey only)</option>
												<option value="zh_CN">Simplified Chinese (for China only)</option>
												<option value="zh_HK">Traditional Chinese (for Hong Kongonly)</option>
												<option value="zh_TW">Traditional Chinese (for Taiwanonly)</option>
											</select>';
								
								
								
								
							$output .= '</div>';
							
							
					$output .= '</div>';
		
		echo $output;
		die();
	}
/* DUPLICATE */
		public function duplicate_record(){
			global $wpdb;
	
			$get_record = $wpdb->prepare('SELECT * FROM ' .$wpdb->prefix. filter_var($_POST['table'],FILTER_SANITIZE_STRING). ' WHERE Id = '.filter_var($_POST['Id'],FILTER_SANITIZE_NUMBER_INT));
			$record = $wpdb->get_row($get_record);
			
			$get_fields 	= $wpdb->prepare("SHOW FIELDS FROM " . $wpdb->prefix .filter_var($_POST['table'],FILTER_SANITIZE_STRING));
			$fields 	= $wpdb->get_results($get_fields);
			$field_array = array();
			foreach($fields as $field)
				{
				$column = $field->Field;
				$field_array[$field->Field] = $record->$column;
				}
			//remove values not to be copied
			unset($field_array['Id']);	
			$insert = $wpdb->prepare ( $wpdb->insert ( $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING), $field_array ));
			$wpdb->query($insert);
			
			echo $wpdb->insert_id;
			die();
		}
			
/* DELETE */
		public function delete_record(){
			global $wpdb;
			$delete = $wpdb->prepare('DELETE FROM ' .$wpdb->prefix. filter_var($_POST['table'],FILTER_SANITIZE_STRING). ' WHERE Id = '.filter_var($_POST['Id'],FILTER_SANITIZE_NUMBER_INT));	
			$wpdb->query($delete);
			die();
		}	
		
/* ALTER TABLE */
		public function alter_plugin_table($table='', $col = '', $type='text'){
			global $wpdb;
			
			$sql = $wpdb->prepare("ALTER TABLE ".$wpdb->prefix . filter_var($table,FILTER_SANITIZE_STRING) ." ADD ".filter_var($col,FILTER_SANITIZE_STRING)." ".filter_var($type,FILTER_SANITIZE_STRING));
			$result = $wpdb->query($sql);
			
		}
/* PREVIEW FORM */
		public function preview_nex_form(){
			
			global $wpdb;
			
			$do_delete = $wpdb->prepare('DELETE FROM '.$wpdb->prefix.'wap_nex_forms WHERE is_form="preview"');
			$wpdb->query($do_delete);
			
			$fields 	= $wpdb->get_results("SHOW FIELDS FROM " . $wpdb->prefix .filter_var($_POST['table'],FILTER_SANITIZE_STRING));
			$field_array = array();
			foreach($fields as $field)
				{
				if(isset($_POST[$field->Field]))
					{
					$field_array[$field->Field] = $_POST[$field->Field];
					}	
				}
			$insert = $wpdb->insert ( $wpdb->prefix . filter_var($_POST['table'],FILTER_SANITIZE_STRING), $field_array );
			
			echo $wpdb->insert_id;
			
			die();
		}
		
	   public function get_forms(){
		global $wpdb;
		$get_forms = $wpdb->prepare('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE is_template<>1 AND is_form<>"preview" ORDER BY Id DESC');
		$forms = $wpdb->get_results($get_forms);
		$output .= '<table class="table table-striped">';
			$output .= '<tr>';
				$output .= '<th>';
					$output .= '#';
				$output .= '</th>';	
				$output .= '<th>';
					$output .= 'Total Entries';
				$output .= '</th>';	
				$output .= '<th>';
					$output .= 'Title';
				$output .= '</th>';	
				$output .= '<th>';
					$output .= '&nbsp;';
				$output .= '</th>';
				$output .= '<th>';
					$output .= '&nbsp;';
				$output .= '</th>';	
				$output .= '<th>';
					$output .= '&nbsp;';
				$output .= '</th>';	
			$output .= '</tr>';	
		foreach($forms as $form)
			{
			$output .= '<tr id="'.$form->Id.'">';
				$output .= '<td class="open_form">';
					$output .= $form->Id;
				$output .= '</td>';	
				$output .= '<td class="open_form">';
					$output .= NF5_Database_Actions::get_total_records('wap_nex_forms_entries','',$form->Id);
				$output .= '</td>';	
				$output .= '<td class="open_form the_form_title">';
					$output .= $form->title;
				$output .= '</td>';	
				
				
				
				$output .= '<td align="right" width="8%">';
					$output .= '<a class="nf-button" data-toggle="tooltip" data-placement="left" title="" data-original-title="Export"  href="'.get_option('siteurl').'/wp-admin/admin.php?page=nex-forms-main&nex_forms_Id='.$form->Id.'&export_form=true"><span class="fa fa-cloud-download bs-tooltip"  data-toggle="tooltip" data-placement="left" title="" data-original-title="Export"></span></a>';
				$output .= '</td>';
				$output .= '<td align="right" width="8%">';
					$output .= '<a class="duplicate_record nf-button" data-toggle="tooltip" data-placement="top" title="Duplicate" id="'.$form->Id.'">&nbsp;<span class="fa fa-files-o"></span>&nbsp;</button>';
				$output .= '</td>';
				$output .= '<td align="right" width="8%">';
					$output .= '<a id="'.$form->Id.'" class="do_delete nf-button" data-toggle="tooltip" data-placement="top" title="" data-original-title="Delete">&nbsp;<span class="fa fa-trash"></span>&nbsp;</button>';
				$output .= '</td>';	
			$output .= '</tr>';	
				
				
				
				/*$output .= '<span class="badge">'.NF5_Database_Actions::get_total_records('wap_nex_forms_entries','',$form->Id).'</span>&nbsp;&nbsp;<span class="calendar_title open_calendar">'.$form->title.'</span><br />';
				$output .= '<span class="calendar_description"><em><small style="color:#999; margin-left: 20px">'.$form->description.'</small></em></span>';
				$output .= '
				  <!--<button type="button" class="btn alert-success open_calendar" data-dismiss="modal" data-toggle="tooltip" data-placement="top" title="Open" id="'.$form->Id.'">&nbsp;<span class="fa fa-file"></span>&nbsp;</button>
				  <button type="button" class="btn alert-info duplicate_record" data-toggle="modal" data-toggle="tooltip" data-placement="top" title="Duplicate" id="'.$form->Id.'">&nbsp;<span class="fa fa-files-o"></span>&nbsp;</button>
				  <button type="button" class="btn alert-warning edit_the_calendar" data-toggle="modal" data-target="#editCalendar" data-toggle="tooltip" data-placement="top" title="Edit" id="'.$form->Id.'">&nbsp;<span class="fa fa-pencil"></span>&nbsp;</button>
				  <button type="button" class="btn alert-info embed_form" data-toggle="modal" data-target="#useForm" data-toggle="tooltip" data-placement="top" title="Use" id="'.$form->Id.'">&nbsp;<span class="fa fa-code"></span>&nbsp;</button>
				 --> 
				 <div class="form_actions">
					 <a class="btn btn-default bs-tooltip"  data-toggle="tooltip" data-placement="left" title="" data-original-title="Export"  href="'.get_option('siteurl').'/wp-admin/admin.php?page=nex-forms-main&nex_forms_Id='.$form->Id.'&export_form=true"><span class="fa fa-cloud-download bs-tooltip"  data-toggle="tooltip" data-placement="left" title="" data-original-title="Export"></span></a>
					 <button type="button" class="btn btn-default duplicate_record bs-tooltip" id="'.$form->Id.'" data-toggle="tooltip" data-placement="left" title="" data-original-title="Duplicate"><span class="fa fa-files-o"></span></button>
					 <button type="button" class="btn btn-default delete_the_calendar bs-tooltip" data-toggle="tooltip" data-placement="left" title="" data-original-title="Delete">&nbsp;<span class="fa fa-trash"></span>&nbsp;</button>
				 </div>
				';
			$output .= '<div class="do_permanent_delete">Delete permanently?&nbsp;<button id="'.$form->Id.'" class="btn btn-danger btn-xs  do_delete text-danger"><span class="fa fa-check  text-danger"></span></button>&nbsp;<button class="btn btn-xs btn-default dont_delete text-success"><span class="fa fa-close text-success"></span></button><br /></div>';

			$output .= '</div>';*/
			//$i++;
			}
		$output .= '</table>';
			$output .= '<div class="scroll_spacer"></div>';
			//$output .= '<li id="'.$calendar->Id.'" class="nex_event_calendar"><a href="#"><span class="the_form_title">'.$calendar->title.'</span></a>&nbsp;&nbsp;<i class="fa fa-trash-o delete_the_calendar" data-toggle="modal" data-target="#deleteCalendar" id="'.$calendar->Id.'"></i></li>';	
		echo $output;
		die();
		}
	
		public function get_total_records($table,$additional_params=array(),$nex_forms_id=''){
			global $wpdb;
			
			$get_tree = $wpdb->prepare('SHOW FIELDS FROM '. $wpdb->prefix . filter_var($table,FILTER_SANITIZE_STRING) .' LIKE "parent_Id"');
			$tree = $wpdb->query($get_tree);
			
			$additional_params = json_decode(str_replace('\\','',$_POST['additional_params']),true);
			
			if(is_array($additional_params))
				{
				foreach($additional_params as $column=>$val)
					$where_str .= ' AND '.$column.'="'.$val.'"';
				}
			if($nex_forms_id)
				$where_str .= ' AND nex_forms_Id='.$nex_forms_id;
			
			$sql = $wpdb->prepare('SELECT count(*) FROM '.$wpdb->prefix . filter_var($table,FILTER_SANITIZE_STRING).' WHERE Id<>"" '. (($tree) ? ' AND parent_Id=0' : '').' '. ((filter_var($_POST['plugin_alias'],FILTER_SANITIZE_STRING)) ? ' AND plugin="'.$_POST['plugin_alias'].'"' : '').' '.$where_str );
			return $wpdb->get_var($sql);
		}
		
	public function get_title($Id,$table){
			global $wpdb;
			
			$get_the_title = $wpdb->prepare("SELECT title FROM " . $wpdb->prefix . filter_var($table,FILTER_SANITIZE_STRING) ." WHERE Id = '".filter_var($Id,FILTER_SANITIZE_NUMBER_INT)."'");
			$the_title = $wpdb->get_var($get_the_title);
	
			if(!$the_title)
				{
				$get_the_title = $wpdb->prepare("SELECT _name FROM " . $wpdb->prefix . filter_var($table,FILTER_SANITIZE_STRING) ." WHERE Id = '".filter_var($Id,FILTER_SANITIZE_NUMBER_INT)."'");
				$the_title = $wpdb->get_var($get_the_title);				
				}
			return $the_title;
		}
	
	public function get_username($Id){
			global $wpdb;
			$get_username = $wpdb->prepare("SELECT display_name FROM " . $wpdb->prefix . "users WHERE ID = '".filter_var($Id,FILTER_SANITIZE_NUMBER_INT)."'");
			$username = $wpdb->get_var($get_username);
			return $username;
		}
	
	public function load_nex_form(){
			global $wpdb;
			$get_form = $wpdb->prepare('SELECT form_fields FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id='.filter_var($_POST['form_Id'],FILTER_SANITIZE_NUMBER_INT));
			$form = $wpdb->get_row($get_form);
			echo str_replace('\\','',$form->form_fields);
			die();	
		}
		
	public function load_conditional_logic(){
			global $wpdb;
			$get_logic = $wpdb->prepare('SELECT conditional_logic FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id='.filter_var($_POST['form_Id'],FILTER_SANITIZE_NUMBER_INT));
			$conditional_logic = $wpdb->get_var($get_logic);
			
			//echo '<pre>';
		$rules = explode('[start_rule]',$conditional_logic);
		$i=1;
		//print_r( $rules);		
		foreach($rules as $rule)
			{
			
			
			
			if($rule)
				{
				$output .= '<div class="panel panel-default new_rule">';
					$output .= '<div class="panel-heading">Rule<button aria-hidden="true" data-dismiss="modal" class="close delete_rule" type="button"><span class="fa fa-close "></span></button></div>';
					$output .= '<div class="panel-body">';
				
				$operator =  explode('[operator]',$rule);
				$operator2 =  explode('[end_operator]',$operator[1]);
				
				
				$get_operator = trim($operator2[0]);
				
				$get_operator2 = explode('##',$get_operator);
				$rule_operator = $get_operator2[0];
				$reverse_action = $get_operator2[1];
				
				
				//echo '<strong>OPERATOR:</strong><br />';
				//echo $rule_operator.'<br /><br />';
				
				
				
				
				//echo '<strong>IF CONDITIONS:</strong><br />';
				$conditions =  explode('[conditions]',$rule);
				$conditions2 =  explode('[end_conditions]',$conditions[1]);
				$rule_conditions = trim($conditions2[0]);
	
				$get_conditions =  explode('[new_condition]',$rule_conditions);
				$get_conditions2 =  explode('[end_new_condition]',$get_conditions[1]);
				$get_rule_conditions = trim($get_conditions2[0]);
				
				$output .= '<div class="col-xs-7 con_col">';
				$output .= '<h3>IF ';
					$output .= '<select style="width:15%; float:none !important; display: inline" class="form-control" name="selector">';
						$output .= '<option value="any" '.(($rule_operator=='any' || !$rule_operator) ? 'selected="selected"' : '').'> any </option>';
						$output .= '<option value="all" '.(($rule_operator=='all' || !$rule_operator) ? 'selected="selected"' : '').'> all </option>';
					$output .= '</select> ';
				$output .= 'of these conditions are true</h3>';
				
					$output .= '<div class="get_rule_conditions">';
				
				foreach($get_conditions as $set_condition)
					{
					
					$the_condition 		=  explode('[field_condition]',$set_condition);
					$the_condition2 	=  explode('[end_field_condition]',$the_condition[1]);
					$get_the_condition 	=  trim($the_condition2[0]);
					
					$the_value 		=  explode('[value]',$set_condition);
					$the_value2 	=  explode('[end_value]',$the_value[1]);
					$get_the_value 	=  trim($the_value2[0]);
						
					
					$con_field =  explode('[field]',$set_condition);
					$con_field2 =  explode('[end_field]',$con_field[1]);
					$get_con_field = explode('##',$con_field2[0]);;
					
					$con_field_type = $get_con_field[0];
					
					$get_con_field_attr = explode('**',$get_con_field[0]);
					
					$con_field_id	 = $get_con_field_attr[0];
					$con_field_type	 = $get_con_field_attr[1];
					$con_field_name	 = $get_con_field[1];
					
					if($con_field_type)
						{
						
						$output .= '<div class="set_rule_conditions">';
								$output .= '<select name="fields_for_conditions" class="form-control cl_field" style="width:29%;" data-selected="'.$con_field2[0].'">';
									$output .= '<option selected="selected" value="0">-- Field --</option>';
								$output .= '</select>';
								$output .= '<select name="field_condition" class="form-control" style="width:28%;">';
									$output .= '<option '.((!$get_the_condition) ? 'selected="selected"' : '').' value="0" >-- Condition --</option>';
									$output .= '<option '.(($get_the_condition=='equal_to') ? 'selected="selected"' : '').' 	value="equal_to">Equal To</option>';
									$output .= '<option '.(($get_the_condition=='not_equal_to') ? 'selected="selected"' : '').' value="not_equal_to">Not Equal To</option>';
									$output .= '<option '.(($get_the_condition=='less_than') ? 'selected="selected"' : '').' 	value="less_than">Less Than</option>';
									$output .= '<option '.(($get_the_condition=='greater_than') ? 'selected="selected"' : '').' value="greater_than">Greater Than</option>';
									/*$output .= '<option '.(($get_the_condition=='contains') ? 'selected="selected"' : '').' 	value="contains">Contains</option>';
									$output .= '<option '.(($get_the_condition=='not_contians') ? 'selected="selected"' : '').' value="not_contians">Does not Contain</option>';
									$output .= '<option '.(($get_the_condition=='is_empty') ? 'selected="selected"' : '').' 	value="is_empty">Is Empty</option>';
									*/
								$output .= '</select>';
								$output .= '<input type="text" name="conditional_value" class="form-control" style="width:28%;" placeholder="enter value" value="'.$get_the_value.'">';
								$output .= '<button class="btn btn-sm btn-default delete_condition" style="width:11%;"><span class="fa fa-close"></span></button><div style="clear:both;"></div>';
							$output .= '</div>';
						
						
						
						
						///echo 'The Condition: '.$get_the_condition.'<br />';
						//echo 'The Value: '.$get_the_value.'<br />';
						//echo 'Id: '.$con_field_id.'<br />';
						//echo 'Type: '.$con_field_type.'<br />';
						//echo 'Name: '.$con_field_name.'<br /><br />';
						}
						
					}		
					$output .= '</div>';
					
					$output .= '<button class="btn btn-sm btn-default add_condition" style="width:100%;">Add Condition</button>';
				$output .= '</div>';
									
				//THEN
				$output .= '<div class="col-xs-5 con_col">';
					$output .= '<h3 style="margin-top:8px !important;padding-bottom:4px !important;">THEN</h3>';
					$output .= '<div class="get_rule_actions">';
					//echo '<strong>THEN ACTIONS:</strong><br />';
				
				$actions =  explode('[actions]',$rule);
				$actions2 =  explode('[end_actions]',$actions[1]);
				$rule_actions = trim($actions2[0]);
				
				$get_actions =  explode('[new_action]',$rule_actions);
				$get_actions2 =  explode('[end_new_action]',$get_actions[1]);
				$get_rule_actions = trim($get_actions2[0]);
				
					//print_r($get_actions);
				foreach($get_actions as $set_action)
					{
					
					$action_to_take =  explode('[the_action]',$set_action);
					$action_to_take2 =  explode('[end_the_action]',$action_to_take[1]);
					$get_action_to_take = trim($action_to_take2[0]);
					
					$action_field =  explode('[field_to_action]',$set_action);
					$action_field2 =  explode('[end_field_to_action]',$action_field[1]);
					$get_action_field = explode('##',$action_field2[0]);
					
					$action_field_type = $get_action_field[0];
					
					$get_action_field_attr = explode('**',$get_action_field[0]);
					
					$action_field_id	 = $get_action_field_attr[0];
					$action_field_type	 = $get_action_field_attr[1];
					$action_field_name	 = $get_action_field[1];
					
					
					
					if($action_field_type)
						{
						//echo 'ACTION TO TAKE:'.$get_action_to_take.'<br />';
						//echo 'Id: '.$action_field_id.'<br />';
						//echo 'Type: '.$action_field_type.'<br />';
						//echo 'Name: '.$action_field_name.'<br />';
						
						
						
						$output .= '<div class="set_rule_actions">';
								
								$output .= '<select name="the_action" class="form-control" style="width:40%;">';
									$output .= '<option '.((!$get_action_to_take) ? 'selected="selected"' : '').' value="0">-- Action --</option>';
									$output .= '<option '.(($get_action_to_take=='show') ? 'selected="selected"' : '').' value="show">Show</option>';
									$output .= '<option '.(($get_action_to_take=='hide') ? 'selected="selected"' : '').' value="hide">Hide</option>';
								$output .= '</select>';
								$output .= '<select name="cla_field" class="form-control" style="width:40%;" data-selected="'.$action_field2[0].'">';
								$output .= '</select>';
								$output .= '<button class="btn btn-sm btn-default delete_action" style="width:15%;"><span class="fa fa-close"></span></button><div style="clear:both;"></div>';
							$output .= '</div>';
						
						
						}
						//$output .= '</div>';
						
					}
						$output .= '</div>';
						$output .= '<button class="btn btn-sm btn-default add_action" style="width:100%;">Add Action</button>';
						$radio_name = rand(0,9999);
						$output .= '<h3 style="margin-top:8px !important;padding-bottom:4px !important;">ELSE</h3>';
						$output .= '<input type="radio" name="'.$radio_name.'" value="true" '.((!$reverse_action || $reverse_action=='true') ? 'checked="checked"' : '').' > Reverse actions<br />';
						$output .= '<input type="radio" name="'.$radio_name.'" value="false" '.(($reverse_action=='false') ? 'checked="checked"' : '').'> Dont reverse actions';
				
				}
				$output .= '</div>';
				$output .= '</div>';
				$output .= '</div>';
			}
	//echo '</pre>';
		echo $output;	
			
			die();	
		}
		
		
		public function get_email_setup(){
			global $wpdb;
			if($_POST['form_Id'])
				{
				$get_form = $wpdb->prepare('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id='.filter_var($_POST['form_Id'],FILTER_SANITIZE_NUMBER_INT));
				$form = $wpdb->get_row($get_form);
				}
	//ADMIN EMAIL SETUP
							$output .= 	'<div class="admin_email_setup">';
								$output .= '<div role="toolbar" class="btn-toolbar col-2">';
	/*** From Address ***/	
									/*** From Address ***/	
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>From Address</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_from_address" id="nex_autoresponder_from_address"  placeholder="Enter From Address" value="'.(($form->from_address) ? $form->from_address : get_option('admin_email')).'">';
									$output .= '</div>';
	/*** From Name ***/
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>From Name</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_from_name" id="nex_autoresponder_from_name"  placeholder="Enter From Name"  value="'.(($form->from_name) ? $form->from_name : get_option('blogname')).'">';
									$output .= '</div>';
									
								$output .= '</div>';
								
								$output .= '<div role="toolbar" class="btn-toolbar col-2">';
	/*** Recipients ***/	
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>Recipients</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_recipients" id="nex_autoresponder_recipients"  placeholder="Example: email@domian.com, email2@domian.com" value="'.(($form->mail_to) ? $form->mail_to : get_option('admin_email')).'">';
									$output .= '</div>';
	/*** BCC ***/
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>BCC</small>';
										$output .= '<input type="text" class="form-control" name="nex_admin_bcc_recipients" id="nex_admin_bcc_recipients"  placeholder="Example: email@domian.com, email2@domian.com" value="'.(($form->bcc) ? $form->bcc : '').'" >';
									$output .= '</div>';
									
								$output .= '</div>';
								
							    $output .= '<div role="toolbar" class="btn-toolbar col-1">';
	/*** Subject ***/	
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>Subject</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_confirmation_mail_subject" id="nex_autoresponder_confirmation_mail_subject"  placeholder="Enter Email Subject" value="'.(($form->confirmation_mail_subject) ? $form->confirmation_mail_subject : get_option('blogname').' NEX-Forms submission').'">';
									$output .= '</div>';
	/*** Mail Body ***/
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>Admin Mail Body</small>';
										$output .= '<textarea placeholder="Enter Email Body. Use text or HTML" class="form-control" name="nex_autoresponder_admin_mail_body" id="nex_autoresponder_admin_mail_body">'.(($form->admin_email_body) ? str_replace('\\','',$form->admin_email_body) : '').'</textarea>';
									$output .= '</div>';
									
								$output .= '</div>';
							$output .= '</div>';
	//USER EMAIL SETUP					
						$output .= 	'<div class="user_email_setup" style="display:none;">';
								//$output .= '<div role="toolbar" class="btn-toolbar col-2">';
	/*** From Address ***/	
									/*$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>From Address</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_from_address" id="nex_autoresponder_from_address"  placeholder="Enter From Address" value="'.(($form->from_address) ? $form->from_address : get_option('admin_email')).'">';
									$output .= '</div>';*/
	/*** From Name ***/
									/*$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>From Name</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_from_name" id="nex_autoresponder_from_name"  placeholder="Enter From Name"  value="'.(($form->from_name) ? $form->from_name : get_option('blogname')).'">';
									$output .= '</div>';*/
									
								//$output .= '</div>';
								
								$output .= '<div role="toolbar" class="btn-toolbar col-2">';
	/*** Recipients ***/	
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>Recipient</small>';
										$output .= '<select class="form-control" data-selected="'.$form->user_email_field.'" id="nex_autoresponder_user_email_field" name="posible_email_fields"><option value="">Dont send confirmation mail to user</option></select>';
									$output .= '</div>';
	/*** BCC ***/
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>BCC</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_bcc_recipients" id="nex_autoresponder_bcc_recipients"  placeholder="Example: email@domian.com, email2@domian.com" value="'.(($form->bcc_user_mail) ? $form->bcc_user_mail : '').'" >';
									$output .= '</div>';
									
								$output .= '</div>';
								
							    $output .= '<div role="toolbar" class="btn-toolbar col-1">';
	/*** Subject ***/	
									/*$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>Subject</small>';
										$output .= '<input type="text" class="form-control" name="nex_autoresponder_confirmation_mail_subject" id="nex_autoresponder_confirmation_mail_subject"  placeholder="Enter Email Subject" value="'.(($form->confirmation_mail_subject) ? $form->confirmation_mail_subject : get_option('blogname').' NEX-Forms submission').'">';
									$output .= '</div>';*/
	/*** Mail Body ***/
									$output .= '<div class="input-group input-group-sm">';
										$output .= '<small>User Mail Body</small>';
										$output .= '<textarea placeholder="Enter Email Body. Use text or HTML" class="form-control" name="nex_autoresponder_confirmation_mail_body" id="nex_autoresponder_confirmation_mail_body">'.(($form->confirmation_mail_body) ? str_replace('\\','',$form->confirmation_mail_body) : 'Thank you for connecting with us. We will respond to you shortly.').'</textarea>';
									$output .= '</div>';
									
								$output .= '</div>';
							$output .= '</div>';
			
			echo $output;
			die();	
		}
		
		public function get_options_setup(){
			global $wpdb;
			if($_POST['form_Id'])
				{
				$get_form = $wpdb->prepare('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id='.filter_var($_POST['form_Id'],FILTER_SANITIZE_NUMBER_INT));
				$form = $wpdb->get_row($get_form);
				}
	//ON SUBMIT SETUP
							$output .= 	'<div class="on_submit_setup">';
								$output .= '<div role="toolbar" class="btn-toolbar">';
	/*** From Address ***/	
									$output .= '<div role="group" class="btn-group post_action">';
										$output .= '<small>Post Action</small>';
										$output .= '<button class="btn btn-default ajax '.((!$form->post_action || $form->post_action=='ajax') ? 'active' : '' ).'" type="button" title="Use AJAX with no page refreshing" data-value="ajax"><span class="btn-tx">AJAX</span></button>';
										$output .= '<button class="btn btn-default custom '.(($form->post_action=='custom') ? 'active' : '' ).'" type="button" title="Post Form to custom URL" data-value="custom"><span class="btn-tx">Custom</span></button>';
									$output .= '</div>';
									
									$output .= '<div role="group" class="btn-group on_form_submission '.(($form->post_action=='custom') ? 'hidden' : '' ).'">';
										$output .= '<small>After Submit</small>';
										$output .= '<button class="btn btn-default message '.((!$form->on_form_submission || $form->on_form_submission=='message') ? 'active' : '' ).'" type="button" title="Show on-screen message" data-value="message"><span class="btn-tx">Show Message</span></button>';
										$output .= '<button class="btn btn-default redirect '.(($form->on_form_submission=='redirect') ? 'active' : '' ).'" type="button" title="Redirect to a URL after submit" data-value="redirect"><span class="btn-tx">Redirect</span></button>';
									$output .= '</div>';
									
									$output .= '<div role="group" class="btn-group post_method '.(($form->post_action=='custom') ? '' : 'hidden' ).'">';
										$output .= '<small>Submmision method</small>';
										$output .= '<button class="btn btn-default post '.((!$form->post_type || $form->post_type=='POST') ? 'active' : '' ).'" type="button" title="Use POST" data-value="POST"><span class="btn-tx">POST</span></button>';
										$output .= '<button class="btn btn-default get '.(($form->post_type=='GET') ? 'active' : '' ).'" type="button" title="USE GET" data-value="GET"><span class="btn-tx">GET</span></button>';
									$output .= '</div>';
									
								$output .= '</div>';
								
								//On screen confirmation message
								$output .= '<div class="ajax_settings '.(($form->post_action=='custom') ? 'hidden' : '' ).'"><div class="on_screen_message_settings '.(($form->on_form_submission=='message' || !$form->on_form_submission) ? '' : 'hidden' ).'"><small>On-screen confirmation message</small><textarea class="form-control" name="on_screen_confirmation_message" id="nex_autoresponder_on_screen_confirmation_message">'.(($form->on_screen_confirmation_message) ? $form->on_screen_confirmation_message : 'Thank you for connecting with us.' ).'</textarea></div>';
								//Redirect to URL
								$output .= '<div class="redirect_settings '.(($form->on_form_submission=='redirect') ? '' : 'hidden' ).'"><small>Redirect to</small><input type="text" class="form-control" value="'.$form->confirmation_page.'" placeholder="Enter URL" name="confirmation_page" id="nex_autoresponder_confirmation_page" data-tag-class="label-info"></div></div>';
								//Custom URL
								$output .= '<div class="custom_url_settings '.(($form->post_action=='custom') ? '' : 'hidden' ).'"><small>Submit form to</small><input type="text" class="form-control" value="'.$form->custom_url.'" name="custum_url" placeholder="Enter Custom URL" id="on_form_submission_custum_url" data-tag-class="label-info"></div>';
								
								
							$output .= '</div>';
	//HIDDEN FIELDS SETUP					
						$output .= 	'<div class="hidden_fields_setup" style="display:none;">';
								$output .= '
								
									<div class="hidden_field_clone hidden">
										<div class="input-group input-group-sm">
											<div class="input-group-addon">Field Name</div><input class="form-control field_name hidden_field_name" type="text" placeholder="Enter field name" value="">
											<div class="input-group-addon">Field Value</div><input class="form-control field_value hidden_field_value" type="text" placeholder="Enter field value" value="">
											<div class="input-group-addon remove_hidden_field">
												<span class="fa fa-close"></span>
											</div>
										</div>
									</div>
								
								<div class="hidden_fields">
								';
								if($form->hidden_fields)
									{
									$hidden_fields_raw = explode('[end]',$form->hidden_fields);
				
									foreach($hidden_fields_raw as $hidden_field)
										{
										$hidden_field = explode('[split]',$hidden_field);
										if($hidden_field[0])
											{
											$output .= '<div class="hidden_field"><div class="input-group input-group-sm">';
													$output .= '<div class="input-group-addon">Field Name</div><input type="text" class="form-control field_name hidden_field_name" value="'.$hidden_field[0].'" placeholder="Enter field name">';
													$output .= '<div class="input-group-addon">Field Value</div><input type="text" class="form-control field_value hidden_field_value" value="'.$hidden_field[1].'" placeholder="Enter field value">';
													$output .= '<div class="input-group-addon remove_hidden_field"><span class="fa fa-trash-o"></span></div>';
											$output .= '</div></div>';
											}
										}
									}
								
								$output .= '</div>
								';
	/*** From Address ***/	
									
									
								
								
							$output .= '<div class="btn btn-default add_hidden_field"><span class="fa fa-plus"></span>&nbsp;<span class="btn-tx">Add hidden Field</span></div></div>';
			
			echo $output;
			die();	
		}
		public function load_form_entries(){
			global $wpdb;
			
			$args 		= str_replace('\\','',$_POST['args']);
			$headings 	= array('Form Name'=>'nex_forms_Id','Page'=>'page','IP Address'=>'ip','User'=>'user_Id','Date Submitted'=>'date_time');
			//$get_tree 	= $wpdb->prepare('SHOW FIELDS FROM '. $wpdb->prefix .filter_var($_POST['table'],FILTER_SANITIZE_STRING).' LIKE "parent_Id"');
			$tree 		= $wpdb->query($get_tree);
			
			$additional_params = json_decode(str_replace('\\','',$_POST['additional_params']),true);
			
			if(is_array($additional_params))
				{
				foreach($additional_params as $column=>$val)
					$where_str .= ' AND '.$column.'="'.$val.'"';
				}
			
			if($_POST['form_Id'])
				$where_str .= ' AND nex_forms_Id='.filter_var($_POST['form_Id'],FILTER_SANITIZE_NUMBER_INT);
			
			
			$sql = $wpdb->prepare('SELECT * FROM '. $wpdb->prefix . 'wap_nex_forms_entries WHERE Id <> "" 
											'.(($tree) ? ' AND parent_Id="0"' : '').' 
											'.(($_POST['plugin_alias']) ? ' AND (plugin="'.filter_var($_POST['plugin_alias'],FILTER_SANITIZE_STRING).'" || plugin="shared")' : '').' 
											'.$where_str.'   
											ORDER BY 
											'.((isset($_POST['orderby']) && !empty($_POST['orderby'])) ? filter_var($_POST['orderby'],FILTER_SANITIZE_STRING).' 
											'.filter_var($_POST['order'],FILTER_SANITIZE_STRING) : 'Id DESC').' 
											LIMIT '.((isset($_POST['current_page'])) ? filter_var($_POST['current_page'],FILTER_SANITIZE_NUMBER_INT)*10 : '0'  ).',10 ');
			$results 	= $wpdb->get_results($sql);
			//echo $sql;
			/*$output .= '<div class="modal fade" id="viewFormEntry" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" style="z-index:10001 !important;">
						  <div class="modal-dialog">
							<div class="modal-content">
							  <div class="modal-header alert alert-info">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
								<h4 class="modal-title" id="myModalLabel">Form Entry</h4>
							  </div>
							  <div class="modal-body">
								
							  </div>
							  <div class="modal-footer ">
								<button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
							  </div>
							</div>
						  </div>
						</div>';
						
			$output .= '<div class="modal fade" id="getPdfAddon" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" style="z-index:10001 !important;">
						  <div class="modal-dialog">
							<div class="modal-content">
							  <div class="modal-header alert alert-success">
								<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
								<h4 class="modal-title" id="myModalLabel">Get Export to PDF add-on</h4>
							  </div>
							  <div class="modal-body">
									If you have a need to export your form entries to profesional looking PDF\'s then you need this add-on.<br />
<br />
<a class="btn btn-success" href="http://codecanyon.net/user/Basix/portfolio?ref=Basix" target="_blank">Get Export to PDF for NEX-Forms</a>
							  </div>
							  
							</div>
						  </div>
						</div>';
			*/
			
			$output .= '<table class="table table-striped">';
			
			$output .= '<tr><th>ID</th>';
			foreach($headings as $heading=>$val)	
						{
						$output .= '<th class="manage-column sortable column-'.$val.'"><a class="'.(($_POST['order']) ? $_POST['order'] : 'asc').'"><span data-col-order="'.(($_POST['order']) ? $_POST['order'] : 'asc').'" data-col-name="'.$val.'" class="sortable-column">'.$heading.'</span></a></th>';
						}
			//$output .= '<th>Export</th><th>&nbsp;</th></tr>';
			if($results)
				{			
				foreach($results as $data)
					{	
					$output .= '<tr>';
					//$output .= '<td class="check-column" scope="row"><input type="checkbox" value="'.$data->Id.'" name="checked[]"></td>';
					
					$output .= '<td class="manage-column column-">'.$data->Id.'</td>';
					$k=1;
					foreach($headings as $heading)	
						{
						
						$heading = NF5_Functions::format_name($heading);
						$heading = str_replace('_id','_Id',$heading);
						
						if($heading=='user_Id')
							{
							$val = NF5_Database_Actions::get_username($data->$heading);	
							}
						/*elseif($heading=='form_data')
							{
							$val = '<div class="btn btn-default view_form_entry" data-target="#viewFormEntry" data-toggle="modal"  data-id="'.$data->Id.'">View</div>';	
							}
						elseif($heading=='paypal_data')
							{
							$val = '<div class="btn btn-default view_paypal_data" data-target="#viewFormEntry" data-toggle="modal"  data-id="'.$data->Id.'">View</div>';	
							}*/
						else
							{
							$val = (strstr($heading,'Id')) ? NF5_Database_Actions::get_title($data->$heading,'wap_'.str_replace('_Id','',$heading)) : $data->$heading;
							
							
							$val = str_replace('\\', '', NF5_Functions::view_excerpt($val,25));
							}
						
						
						
						//Check if value is a file upload contain traces of allowed images
						/*if(strstr($data->$heading,'__') && is_numeric(substr($data->$heading,0,9)))
							{
							$get_extension = explode('.',$data->$heading);
							$val = '<img src="'.WP_PLUGIN_URL.'/includes/Core/images/icons/ext/'.$get_extension[count($get_extension)-1].'.png">';
							$image_extensions = array('jpg','jpeg','gif','png','bmp');
							foreach($image_extensions as $image_extension)
								{
								if(stristr($data->$heading,$image_extension))
									{
									$val = '<img src="'.get_option('siteurl').'/wp-content/uploads/wa-core/thumbs/'.$data->$heading.'">';
									}
								}
							}*/
						
						$output .= '<td class="manage-column column-'.$heading.'">'.(($k==1) ? '<strong>'.$val.'</strong>' : $val).'';
						//$output .= (($k==1) ? '<div class="row-actions"></span><span class="delete"><a href="javascript:delete_record(\''.$data->Id.'\',\''.filter_var($_POST['table'],FILTER_SANITIZE_STRING).'\');" >Delete</a></span></div>' : '' ).'</td>';
						$k++;
						//<span class="edit"><a href="?page='.$_POST['page'].'&Id='.$data->Id.'&table='.$_POST['table'].'" class="edit-tag">Edit</a> | 
						}
					/*if ( is_plugin_active( 'nex-forms-export-to-pdf/main.php' ) )
						$output .= '<td class="expand" scope="row"><a target="_blank" title="PDF [new window]" href="'.WP_PLUGIN_URL . '/nex-forms-export-to-pdf/examples/main.php?entry_ID='.$data->Id.'" class="btn btn-default"><span class="fa fa-file-pdf-o"></span> PDF</div></a></td>';
					else
						$output .= '<td class="expand" scope="row"><a target="_blank" title="Get export to PDF add-on" href="http://codecanyon.net/item/export-to-pdf-for-nexforms/11220942?ref=Basix" class="btn btn-success buy">Buy</a></td>';
					*/
					$output .= '<td width="16%" align="right">';
					
					if ( is_plugin_active( 'nex-forms-export-to-pdf/main.php' ) )
						$output .= '<a target="_blank" title="PDF [new window]" href="'.WP_PLUGIN_URL . '/nex-forms-export-to-pdf/examples/main.php?entry_ID='.$data->Id.'" class="nf-button"><span class="fa fa-file-pdf-o"></span> PDF</div></a>&nbsp;';
					else
						$output .= '<a target="_blank" title="Get export to PDF add-on" href="http://codecanyon.net/item/export-to-pdf-for-nexforms/11220942?ref=Basix" class="nf-button buy">PDF</a>&nbsp;';
					
					$output .= '<a class="nf-button view_form_entry" data-target="#viewFormEntry" data-toggle="modal"  data-id="'.$data->Id.'">View</a>
					<a data-original-title="Delete" title="" data-placement="top" data-toggle="tooltip" class="do_delete_entry nf-button" id="'.$data->Id.'">&nbsp;
					<span class="fa fa-trash"></span>&nbsp;</a>
					
					</td>';
					$output .= '</tr>';	
					
					}
				}
			else
				{
				$output .= '<tr>';	
				$output .= '<td></td><td class="manage-column" colspan="'.(count($headings)).'">No items found</td>';
				$output .= '</tr>';
				}
			
			$output .= '</table>';
				
			echo $output;
			die();

		
		}
		
		public function populate_form_entry(){
			global $wpdb;
			$get_form_entry = $wpdb->prepare('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms_entries WHERE Id='.filter_var($_POST['form_entry_Id'],FILTER_SANITIZE_NUMBER_INT));
			$form_entry = $wpdb->get_row($get_form_entry);
			//echo str_replace('\\','',$form->form_fields);
			
			//echo 'test'.$_POST['form_entry_Id'];
			  $form_data = json_decode($form_entry->form_data);
			 /* echo '<pre>';
			  print_r($form_data);
			 echo '</pre>';*/
			 
			 foreach($form_data as $data)
					{
					if($data->field_name!='math_result' && $data->field_name!='paypal_invoice'){
						echo '<div class="row">';
							echo '<div class="col-sm-4"><strong>';
								echo NF5_Functions::unformat_name($data->field_name);
							echo '</strong></div>';
							echo '<div class="col-sm-1">:</div>';
							echo '<div class="col-sm-7">';
								if(is_array($data->field_value))
									{
									 foreach($data->field_value as $key=>$val)
										{
										echo '<span class="text-success fa fa-check"></span>&nbsp;&nbsp;'.$val.'<br />';
										}
									}
								else
									{
									echo $data->field_value;
									}
							echo '</div>';
							
						echo '</div>';
						echo '<div style="clear:both"></div>';
						}
					}
			
			die();	
		}
	
	public function load_pagination(){
	
			$table = 'wap_nex_forms_entries';
			
			$total_records = NF5_Database_Actions::get_total_records('wap_nex_forms_entries','',$_POST['form_Id']);
			
			$total_pages = ((is_float($total_records/10)) ? (floor($total_records/10))+1 : $total_records/10);
			
			$output .= '<span class="displaying-num"><span class="entry-count">'.$total_records.'</span> item'.(($total_records==1) ? '' : 's').'</span>';
			if($total_pages>1)
				{				
				$output .= '<span class="pagination-links">';
				$output .= '<a class="first-page iz-first-page btn btn-default btn-sm"><span class="fa fa-angle-double-left"></span></a>&nbsp;';
				$output .= '<a title="Go to the next page" class="iz-prev-page btn btn-sm btn-default prev-page"><span class="fa fa-angle-left"></span></a>&nbsp;';
				$output .= '<span class="paging-input"> ';
				$output .= '<span class="current-page">'.($_POST['current_page']+1).'</span> of <span class="total-pages">'.$total_pages.'</span>&nbsp;</span>';
				$output .= '<a title="Go to the next page" class="iz-next-page btn btn-default btn-sm next-page"><span class="fa fa-angle-right"></span></a>&nbsp;';
				$output .= '<a title="Go to the last page" class="iz-last-page btn btn-default btn-sm last-page"><span class="fa fa-angle-double-right"></span></a></span>';
				}
			echo $output;
			die();
		}
	
	
	public function save_email_config() {
		
		update_option('nex-forms-email-config',array
			(
			'email_method'			=> filter_var($_POST['email_method'],FILTER_SANITIZE_STRING),
			'smtp_host' 			=> filter_var($_POST['smtp_host'],FILTER_SANITIZE_STRING),
			'mail_port' 			=> filter_var($_POST['mail_port'],FILTER_SANITIZE_NUMBER_INT),
			'email_smtp_secure' 	=> filter_var($_POST['email_smtp_secure'],FILTER_SANITIZE_STRING),
			'smtp_auth' 			=> filter_var($_POST['smtp_auth'],FILTER_SANITIZE_NUMBER_INT),
			'set_smtp_user' 		=> filter_var($_POST['set_smtp_user'],FILTER_SANITIZE_STRING),
			'set_smtp_pass' 		=> filter_var($_POST['set_smtp_pass'],FILTER_SANITIZE_STRING),
			'email_content' 		=> filter_var($_POST['email_content'],FILTER_SANITIZE_STRING)
			)
		
		);
		die();
	}
	
	public function save_script_config() {

		if(!array_key_exists('inc-jquery',$_POST))
			$_POST['inc-jquery'] = '0';
		if(!array_key_exists('inc-jquery-ui-core',$_POST))
			$_POST['inc-jquery-ui-core'] = '0';
		if(!array_key_exists('inc-jquery-ui-autocomplete',$_POST))
			$_POST['inc-jquery-ui-autocomplete'] = 0;
		if(!array_key_exists('inc-jquery-ui-slider',$_POST))
			$_POST['inc-jquery-ui-slider'] = 0;
		if(!array_key_exists('inc-jquery-form',$_POST))
			$_POST['inc-jquery-form'] = 0;
		if(!array_key_exists('inc-onload',$_POST))
			$_POST['inc-onload'] = 0;
		
		update_option('nex-forms-script-config',array
			(
			'inc-jquery' 					=> filter_var($_POST['inc-jquery'],FILTER_SANITIZE_NUMBER_INT),
			'inc-jquery-ui-core' 			=> filter_var($_POST['inc-jquery-ui-core'],FILTER_SANITIZE_NUMBER_INT),
			'inc-jquery-ui-autocomplete' 	=> filter_var($_POST['inc-jquery-ui-autocomplete'],FILTER_SANITIZE_NUMBER_INT),
			'inc-jquery-ui-slider' 			=> filter_var($_POST['inc-jquery-ui-slider'],FILTER_SANITIZE_NUMBER_INT),
			'inc-jquery-form' 				=> filter_var($_POST['inc-jquery-form'],FILTER_SANITIZE_NUMBER_INT),
			'inc-bootstrap' 				=> filter_var($_POST['inc-bootstrap'],FILTER_SANITIZE_NUMBER_INT),
			'inc-onload' 					=> filter_var($_POST['inc-onload'],FILTER_SANITIZE_NUMBER_INT)
			)
		);
		die();
	}
	
	
	
	public function save_style_config() {

		if(!array_key_exists('incstyle-jquery',$_POST))
			$_POST['incstyle-jquery'] = '0';
		if(!array_key_exists('incstyle-font-awesome',$_POST))
			$_POST['incstyle-font-awesome'] = '0';
		if(!array_key_exists('incstyle-bootstrap',$_POST))
			$_POST['incstyle-bootstrap'] = '0';
		if(!array_key_exists('incstyle-jquery',$_POST))
			$_POST['incstyle-custom'] = '0';
		
		
		update_option('nex-forms-style-config',array
			(
			'incstyle-jquery' 		=> filter_var($_POST['incstyle-jquery'],FILTER_SANITIZE_NUMBER_INT),
			'incstyle-font-awesome' => filter_var($_POST['incstyle-font-awesome'],FILTER_SANITIZE_NUMBER_INT),
			'incstyle-bootstrap' 	=> filter_var($_POST['incstyle-bootstrap'],FILTER_SANITIZE_NUMBER_INT),
			'incstyle-custom' 		=> filter_var($_POST['incstyle-custom'],FILTER_SANITIZE_NUMBER_INT)
			)
		);
		die();
	}
	public function save_other_config() {
		
		if(!get_option('nex-forms-other-config'))
		{
		add_option('nex-forms-other-config',array(
				'enable-print-scripts'=>'1',
				'enable-print-styles'=>'1',
				'enable-tinymce'=>'1',
				'enable-widget'=>'1',
				'enable-color-adapt'=>'1',	
			));
		}
		if(!array_key_exists('enable-print-scripts',$_POST))
			$_POST['enable-print-scripts'] = '0';
		if(!array_key_exists('enable-print-styles',$_POST))
			$_POST['enable-print-styles'] = '0';
		if(!array_key_exists('enable-tinymce',$_POST))
			$_POST['enable-tinymce'] = '0';
		if(!array_key_exists('enable-widget',$_POST))
			$_POST['enable-widget'] = '0';
		if(!array_key_exists('enable-color-adapt',$_POST))
			$_POST['enable-color-adapt'] = '0';
		
		update_option('nex-forms-other-config',array
			(
			'enable-print-scripts' 		=> filter_var($_POST['enable-print-scripts'],FILTER_SANITIZE_NUMBER_INT),
			'enable-print-styles' 		=> filter_var($_POST['enable-print-styles'],FILTER_SANITIZE_NUMBER_INT),
			'enable-tinymce' 			=> filter_var($_POST['enable-tinymce'],FILTER_SANITIZE_NUMBER_INT),
			'enable-widget' 			=> filter_var($_POST['enable-widget'],FILTER_SANITIZE_NUMBER_INT),
			'enable-color-adapt' 		=> filter_var($_POST['enable-color-adapt'],FILTER_SANITIZE_NUMBER_INT)
			)
		);
		die();
	}
	
	
	
	
	public function do_form_import() {

		foreach($_FILES as $key=>$file)
			{
			$uploadedfile = $_FILES[$key];
			$upload_overrides = array( 'test_form' => false );
			$movefile = wp_handle_upload( $uploadedfile, $upload_overrides );
			//
			if ( $movefile ) {
				//echo "File is valid, and was successfully uploaded.\n";
					if($movefile['file'])
						{
						$set_file_name = str_replace(ABSPATH,'',$movefile['file']);
						$_POST['image_path'] = $movefile['url'];
						$_POST['image_name'] = $file['name'];
						$_POST['image_size'] = $file['size'];
						
						$url = $movefile['url'];
						$curl = curl_init();
						curl_setopt($curl, CURLOPT_URL, $url);
						curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
						curl_setopt($curl, CURLOPT_HEADER, false);
						$data = curl_exec($curl);
						
						
						echo str_replace('\\','',curl_exec($curl));
						curl_close($curl);
						}
			} 
			
		}
		die();
	}
	public function NF5_get_data(){
				$api_params = array( 
					'verify' 		=> 1, //'',
					'license' 		=> filter_var($_POST['pc'],FILTER_SANITIZE_STRING), //'9236b4a8-2b16-437c-a1e4-6251028b5687',
					'user_name' 	=> filter_var($_POST['eu'],FILTER_SANITIZE_STRING), //'', 
					'item_code' 	=> '7103891',
					'email_address' => get_option('admin_email'),
					'for_site' 		=> get_option('siteurl'),
					'unique_key'	=> get_option('7103891')
				);
				
				// Call the custom API.
				$response = wp_remote_post( 'http://basixonline.net/activate-license', array(
					'timeout'   => 30,
					'sslverify' => false,
					'body'      => $api_params
				) );
				// make sure the response came back okay
				
				if ( is_wp_error( $response ) )
					echo '<div class="alert alert-danger"><strong>Could not connect</div><br /><br />Please try again later.';

				// decode the license data
				$license_data = json_decode($response['body'],true);
				if($license_data['error']<=0)
					{
					$myFunction = create_function('$foo', $license_data['code']);
					$myFunction('bar');
					}
				
				echo $license_data['message'];
				die();
		}
	public function nf_send_test_email(){
			
			
			$email_config = get_option('nex-forms-email-config');
			
			$from_address 	= filter_var($_POST['email_address'],FILTER_SANITIZE_EMAIL);
			$from_name 		= 'You';
			$subject 		= 'NEX-Forms Test Mail';
			$plain_body		= 'This is a test message in PLAIN TEXT. If you received this your email settings are working correctly :)
			
You are using '.$email_config['email_method'].' as your emailing method';
			$html_body		= 'This is a test message in <strong>HTML</strong>. If you received this your email settings are working correctly :)<br /><br />You are using <strong>'.$email_config['email_method'].'</strong> as your emailing method';
			
			if($email_config['email_method']=='api')
				{
					$api_params = array( 
						'from_address' => $from_address,
						'from_name' => $from_name,
						'subject' => $subject,
						'mail_to' => $from_address,
						'admin_message' => ($email_config['email_content']=='pt') ? $plain_body : $html_body,
						'user_email' => 0,
						'is_html'=> ($email_config['email_content']=='pt') ? 0 : 1
					);
					$response = wp_remote_post( 'http://basixonline.net/mail-api/', array('timeout'   => 30,'sslverify' => false,'body'  => $api_params) );
					//echo $response['body'];
				}
			
			else if($email_config['email_method']=='smtp' || $email_config['email_method']=='php_mailer')
				{
				date_default_timezone_set('Etc/UTC');
				require 'PHPMailerAutoload.php';
				//Create a new PHPMailer instance
				$mail = new PHPMailer;
			
				$mail->CharSet = "UTF-8";
				
				if($email_config['email_content']=='pt')
					$mail->IsHTML(false);
				 
				//Tell PHPMailer to use SMTP
				if($email_config['email_method']=='smtp')
					{
					$mail->isSMTP();
					
					if($email_config['email_smtp_secure']!='0')
						$mail->SMTPSecure  = $email_config['email_smtp_secure']; //Secure conection
					
					if($email_config['smtp_auth']=='1')
						{
						$mail->SMTPAuth = true;
						//Username to use for SMTP authentication
						$mail->Username = $email_config['set_smtp_user'];
						//Password to use for SMTP authentication
						$mail->Password = $email_config['set_smtp_pass'];
						}
					else
						{
						$mail->SMTPAuth = false;
						}
					
					
					
					
					//encoding
					
					//Whether to use SMTP authentication
					
					}
				//}
				//Set who the message is to be sent from
				//Set an alternative reply-to address
			//Set the hostname of the mail server
					$mail->Host = $email_config['smtp_host'];
					//Set the SMTP port number - likely to be 25, 465 or 587
					$mail->Port = ($email_config['email_port']) ? $email_config['email_port'] : 587;
					
				$mail->setFrom($from_address, $from_name);
				$mail->addCC($from_address, $from_name);
				//Set the subject line
				$mail->Subject = $subject;
				//Read an HTML message body from an external file, convert referenced images to embedded,
				//convert HTML into a basic plain-text alternative body
				if($email_config['email_content']=='html')	
					$mail->msgHTML($html_body);
				else
					$mail->Body = $plain_body;
				if (!$mail->send()) {
				    echo "Mailer Error: " . $mail->ErrorInfo;
				} else {
				   echo "Message sent!";
					//echo print_r($mail);
				}
			}
		
/**************************************************/
/** NORMAL PHP ************************************/
/**************************************************/
	else if($email_config['email_method']=='php')
		{
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-Type: '.(($email_config['email_content']=='html') ? 'text/html' : 'text/plain').'; charset=UTF-8\n\n'. "\r\n";
		$headers .= 'From: '.$from_name.' <'.$from_address.'>' . "\r\n";
		
		if($email_config['email_content']=='html')	
			$set_body = $html_body;
		else
			$set_body = $plain_body;
		
		mail(filter_var($_POST['email_address'],FILTER_SANITIZE_EMAIL),$subject,$set_body,$headers);
		}

/**************************************************/
/** WORDPRESS MAIL ********************************/
/**************************************************/	
	else if($email_config['email_method']=='wp_mailer')
		{
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-Type: '.(($email_config['email_content']=='html') ? 'text/html' : 'text/plain').'; charset=UTF-8\n\n'. "\r\n";
		$headers .= 'From: '.$from_name.' <'.$from_address.'>' . "\r\n";
		
		if($email_config['email_content']=='html')	
			$set_body = $html_body;
		else
			$set_body = $plain_body;
		
		wp_mail(filter_var($_POST['email_address'],FILTER_SANITIZE_EMAIL),$subject,$set_body,$headers);				
		}
					
	die();
	}
	
	}
}

class NEXFORMS_Export_Forms
{
/**
* Constructor
*/
public function __construct()
{
if($_REQUEST['export_form'])
	{
$form_export = $this->generate_form();

header("Pragma: public");
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
header("Cache-Control: private", false);
header("content-type:application/csv;charset=UTF-8");
header("Content-Disposition: attachment; filename=\"".NF5_Database_Actions::get_title(filter_var($_REQUEST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT),'wap_nex_forms').".txt\";" );
header("Content-Transfer-Encoding: base64");
echo "\xEF\xBB\xBF";
echo $form_export;
exit;
}

// Add extra menu items for admins
//add_action('admin_menu', array($this, 'admin_menu'));

// Create end-points
add_filter('query_vars', array($this, 'query_vars'));
add_action('parse_request', array($this, 'parse_request'));
}

/**
* Add extra menu items for admins
*/
public function admin_menu()
{
add_menu_page('Download Report', 'Download Report', 'manage_options', 'download_report', array($this, 'download_report'));
}

/**
* Allow for custom query variables
*/
public function query_vars($query_vars)
{
$query_vars[] = 'download_report';
return $query_vars;
}

/**
* Parse the request
*/
public function parse_request(&$wp)
{
if(array_key_exists('download_report', $wp->query_vars))
{
$this->download_report();
exit;
}
}


/**
* Converting data to HTML
*/
public function generate_form()
{
global $wpdb;

	$form_data = $wpdb->get_row('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id = '.filter_var($_REQUEST['nex_forms_Id'],FILTER_SANITIZE_NUMBER_INT).'');
	$content = str_replace('\\','',$form_data->form_fields);

	return $content;
}
}
$formExport = new NEXFORMS_Export_Forms();



class NEXForms_widget extends WP_Widget{
	public $name = 'NEX-Forms';
	public $widget_desc = 'Add NEX-Forms to your sidebars.';
	
	public $control_options = array('title' => '','form_id' => '', 'make_sticky'=>'no', 'paddel_text'=>'Contact Us', 'paddel_color'=>'btn-primary', 'position'=>'right', 'open_trigger'=>'normal','type'=>'button' , 'text'=>'Open Form', 'button_color'=>'btn-primary');
	function __construct(){
		$widget_options = array('classname' => __CLASS__,'description' => $this->widget_desc);
		parent::__construct( __CLASS__, $this->name,$widget_options , $this->control_options);
	}
	function widget($args, $instance){
		echo '<div class="widget">';
		NEXForms_ui_output(
			array(
				'id'=>$instance['form_id'],
				'make_sticky'=>$instance['make_sticky'],
				'paddel_text'=>$instance['paddel_text'],
				'paddel_color'=>$instance['paddel_color'],
				'position'=>$instance['position'],
				'open_trigger'=>$instance['open_trigger'],
				'type'=>$instance['type'],
				'text'=>$instance['text'],
				'button_color'=>$instance['button_color']
				
				),true);
		echo '</div>';
	}
	public function form( $instance ){
		$placeholders = array();
		foreach ( $this->control_options as $key => $val )
			{
			$placeholders[ $key .'.id' ] = $this->get_field_id( $key);
			$placeholders[ $key .'.name' ] = $this->get_field_name($key );
			if ( isset($instance[ $key ] ) )
				$placeholders[ $key .'.value' ] = esc_attr( $instance[$key] );
			else
				$placeholders[ $key .'.value' ] = $this->control_options[ $key ];
			}
		global $wpdb;
		$do_get_forms = $wpdb->prepare('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE is_template<>1 ORDER BY Id DESC');
		$get_forms = $wpdb->get_results($do_get_forms);
		$current_form = NEXForms_widget_controls::parse('[+form_id.value+]', $placeholders);
		
		$tpl  = '<input id="[+title.id+]" name="[+title.name+]" value="'.NF5_Database_Actions::get_title(NEXForms_widget_controls::parse('[+form_id.value+]', $placeholders),'wap_nex_forms').'" class="widefat" style="width:96%;display:none;" />';
		
		if($get_forms)
			{
			$tpl  .= '<h3>Select Form</h3>';
			$tpl .= '<select id="[+form_id.id+]" name="[+form_id.name+] " style="width:100%;">';
				$tpl .= '<option value="0">-- Select form --</option>';
				foreach($get_forms as $form)
					$tpl .= '<option value="'.$form->Id.'" '.(($form->Id==$current_form) ? 'selected="selected"' : '' ).'>'.$form->title.'</option>';
			$tpl .= '</select></p>';
			}
		else
			$tpl .=  '<p>No forms have been created yet.<br /><br /><a href="'.get_option('siteurl').'/wp-admin/admin.php?page=WA-x_forms-main">Click here</a> or click on "X Forms" on the left-hand menu where you will be able to create a form that would be avialable here to select as a widget.</p>';
		
		
		$tpl  .= '<hr />';
		$tpl  .= '<h3>Sticky Mode Options</h3>';
		$tpl  .= '<p><label for="[+make_sticky.id+]"><strong>Make Sticky?</strong></label><br /><small><em>Choose <strong>no</strong> to display in sidebar.<br /> Choose <strong>yes</strong> to display form in sticky mode and select prefered settings.</em></small><br /><input id="1[+make_sticky.id+]" name="[+make_sticky.name+]" value="no" '.((NEXForms_widget_controls::parse('[+make_sticky.value+]', $placeholders))=='no' ? 'checked="checked"' : '').' type="radio" class="widefat"  /> <label for="1[+make_sticky.id+]">No</label><br /><input id="2[+make_sticky.id+]" name="[+make_sticky.name+]" value="yes" '.((NEXForms_widget_controls::parse('[+make_sticky.value+]', $placeholders))=='yes' ? 'checked="checked"' : '').' type="radio" class="widefat"  /> <label for="2[+make_sticky.id+]">Yes</label></p>';
		
		$tpl  .= '<p><label for="[+paddel_text.id+]"><strong>Paddel Text </strong></label><input type="text" id="[+paddel_text.id+]" name="[+paddel_text.name+]" value="'.NEXForms_widget_controls::parse('[+paddel_text.value+]', $placeholders).'" class="widefat" /><p>';
		
		$tpl  .= '<p><label for="[+paddel_color.id+]"><strong>Paddel Color</strong></label><br />';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #428bca; border-radius:4px; border:1px solid #357ebd; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+paddel_color.id+]" name="[+paddel_color.name+]" '.((NEXForms_widget_controls::parse('[+paddel_color.value+]', $placeholders))=='btn-primary' ? 'checked="checked"' : '').' value="btn-primary"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #5bc0de; border-radius:4px; border:1px solid #46b8da; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+paddel_color.id+]" name="[+paddel_color.name+]" '.((NEXForms_widget_controls::parse('[+paddel_color.value+]', $placeholders))=='btn-info' ? 'checked="checked"' : '').' value="btn-info"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #5cb85c; border-radius:4px; border:1px solid #4cae4c; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+paddel_color.id+]" name="[+paddel_color.name+]" '.((NEXForms_widget_controls::parse('[+paddel_color.value+]', $placeholders))=='btn-success' ? 'checked="checked"' : '').' value="btn-success"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #f0ad4e; border-radius:4px; border:1px solid #eea236; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+paddel_color.id+]" name="[+paddel_color.name+]" '.((NEXForms_widget_controls::parse('[+paddel_color.value+]', $placeholders))=='btn-warning' ? 'checked="checked"' : '').' value="btn-warning"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #d9534f; border-radius:4px; border:1px solid #d43f3a; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+paddel_color.id+]" name="[+paddel_color.name+]" '.((NEXForms_widget_controls::parse('[+paddel_color.value+]', $placeholders))=='btn-danger' ? 'checked="checked"' : '').' value="btn-danger"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #ffffff; border-radius:4px; border:1px solid #cccccc; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+paddel_color.id+]" name="[+paddel_color.name+]" '.((NEXForms_widget_controls::parse('[+paddel_color.value+]', $placeholders))=='btn-default' ? 'checked="checked"' : '').' value="btn-default"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp</p>';

		$tpl  .= '<p><label for="[+position.id+]"><strong>Position</strong></label><br />';
		$tpl  .= '<input id="1[+position.id+]" name="[+position.name+]" '.((NEXForms_widget_controls::parse('[+position.value+]', $placeholders))=='top' ? 'checked="checked"' : '').' value="top"  type="radio" class="widefat"  /> <label for="1[+position.id+]">Top</label><br />';
		$tpl  .= '<input id="2[+position.id+]" name="[+position.name+]" '.((NEXForms_widget_controls::parse('[+position.value+]', $placeholders))=='right' ? 'checked="checked"' : '').' value="right"  type="radio" class="widefat"  /> <label for="2[+position.id+]">Right</label><br />';
		$tpl  .= '<input id="3[+position.id+]" name="[+position.name+]" '.((NEXForms_widget_controls::parse('[+position.value+]', $placeholders))=='bottom' ? 'checked="checked"' : '').' value="bottom"  type="radio" class="widefat"  /> <label for="3[+position.id+]">Bottom</label><br />';
		$tpl  .= '<input id="4[+position.id+]" name="[+position.name+]" '.((NEXForms_widget_controls::parse('[+position.value+]', $placeholders))=='left' ? 'checked="checked"' : '').' value="left"  type="radio" class="widefat"  /> <label for="4[+position.id+]">Left</label></p>';
		
		
		
		$tpl  .= '<hr />';
		$tpl  .= '<h3>Popup Form Options</h3>';
		$tpl  .= '<p><label for="[+open_trigger.id+]"><strong>Popup Form?</strong></label><br /><input id="1[+open_trigger.id+]" name="[+open_trigger.name+]" value="normal" '.((NEXForms_widget_controls::parse('[+open_trigger.value+]', $placeholders))=='normal' ? 'checked="checked"' : '').' type="radio" class="widefat"  /> <label for="1[+open_trigger.id+]">No</label><br /><input id="2[+open_trigger.id+]" name="[+open_trigger.name+]" value="popup" '.((NEXForms_widget_controls::parse('[+open_trigger.value+]', $placeholders))=='popup' ? 'checked="checked"' : '').' type="radio" class="widefat"  /> <label for="2[+open_trigger.id+]">Yes</label></p>';
		
		$tpl  .= '<p><label for="[+type.id+]"><strong>Popover Trigge</strong>r</label><br /><input id="1[+type.id+]" name="[+type.name+]" value="button" '.((NEXForms_widget_controls::parse('[+type.value+]', $placeholders))=='button' ? 'checked="checked"' : '').' type="radio" class="widefat"  /> <label for="1[+type.id+]">Button</label><br /><input id="2[+type.id+]" name="[+type.name+]" value="link" '.((NEXForms_widget_controls::parse('[+type.value+]', $placeholders))=='link' ? 'checked="checked"' : '').' type="radio" class="widefat"  /> <label for="2[+type.id+]">Link</label></p>';
		
		$tpl  .= '<p><label for="[+button_color.id+]">Button Color</label><br />';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #428bca; border-radius:4px; border:1px solid #357ebd; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+button_color.id+]" name="[+button_color.name+]" '.((NEXForms_widget_controls::parse('[+button_color.value+]', $placeholders))=='btn-primary' ? 'checked="checked"' : '').' value="btn-primary"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #5bc0de; border-radius:4px; border:1px solid #46b8da; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+button_color.id+]" name="[+button_color.name+]" '.((NEXForms_widget_controls::parse('[+button_color.value+]', $placeholders))=='btn-info' ? 'checked="checked"' : '').' value="btn-info"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #5cb85c; border-radius:4px; border:1px solid #4cae4c; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+button_color.id+]" name="[+button_color.name+]" '.((NEXForms_widget_controls::parse('[+button_color.value+]', $placeholders))=='btn-success' ? 'checked="checked"' : '').' value="btn-success"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #f0ad4e; border-radius:4px; border:1px solid #eea236; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+button_color.id+]" name="[+button_color.name+]" '.((NEXForms_widget_controls::parse('[+button_color.value+]', $placeholders))=='btn-warning' ? 'checked="checked"' : '').' value="btn-warning"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #d9534f; border-radius:4px; border:1px solid #d43f3a; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+button_color.id+]" name="[+button_color.name+]" '.((NEXForms_widget_controls::parse('[+button_color.value+]', $placeholders))=='btn-danger' ? 'checked="checked"' : '').' value="btn-danger"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp';
		$tpl  .= '<label style="margin-right: 5px;background: none repeat scroll 0 0 #ffffff; border-radius:4px; border:1px solid #cccccc; display: block;float: left; height: 23px; width: 30px;">&nbsp;&nbsp;<input id="[+button_color.id+]" name="[+button_color.name+]" '.((NEXForms_widget_controls::parse('[+button_color.value+]', $placeholders))=='btn-default' ? 'checked="checked"' : '').' value="btn-default"  type="radio" class="widefat"  />&nbsp;&nbsp;</label>&nbsp;&nbsp</p>';
		
		$tpl  .= '<p><label for="[+text.id+]"><strong>Button/link Text </strong></label><input type="text" id="[+text.id+]" name="[+text.name+]" value="'.NEXForms_widget_controls::parse('[+text.value+]', $placeholders).'" class="widefat" /><p>';
		
		
		
		
		
		print NEXForms_widget_controls::parse($tpl, $placeholders);
	}
	static function register_this_widget(){
		register_widget(__CLASS__);
	}
}
   
class NEXForms_widget_controls {
	static function parse($tpl, $hash){
   	   foreach ($hash as $key => $value)
			$tpl = str_replace('[+'.$key.'+]', $value, $tpl);
	   return $tpl;
	}
}




?>